$(document).ready(function(){
	initSlides();

	$(document).on('click', '.add-new-slideshowSlide', function(){
		var $wrapper = $(this).closest('.slide-tab').find('.slideshow-slide-wrapper:last');
		addNewSlideSlot($wrapper);
		return false;
	});
});

function initSlides() {
	var slides = $('.slideshow-slide');
	reorderSlides = new reorderSlides();

	slides.each(function(){
		reorderSlides.init($(this));
	});

	$('.slideshow-slide-wrapper').delegate('.delete-slide', 'click', function() {
		if ( confirm('Are you sure you want to delete this slide?') ) {

			$.ajax({
				'url': $(this).attr('href')
			});

			$wrapper = $(this).parents('.slideshow-slide-wrapper');

			reorderImgs.remove($(this).parents('.slideshow-slide'));

			$(this).parents('.input').slideUp('normal', function() {
				$(this).remove();
			});

			successNotify({title: 'Slide Deleted', description: 'The selected slide was deleted from the system.'});

			closeNotify(5000);
		}

		return false;
	});

	return;
}

/**
 * Adds a new image slot checking first to see if we have any available ones left.
 */
function addNewSlideSlot($wrapper) {
	row_key = $wrapper.find('.slideshow-slide').length;

	url = "/ajax/slides/add/" + row_key;

	$.ajax({
		url: url,
		context: this,
		success: function(data) {
			data = jQuery.parseJSON(data);

			if (data.status == 'success') {
				$wrapper.append(data.content);

				//TODO: Change to use the chooseFileButton Method
				var _this = $wrapper.find('.file--image').last().find('input[type="file"]');
				var previewTools = _this.parents('.input.preview__tools__input');

				previewTools.addClass('choose-file');

				if (previewTools.length) {
					previewTools.find('label').text('Upload Image');
				}

				// move the add slide button

			}

		}
	});

	return false;
}

function reorderSlides() {
	// Add reordering buttons to file inputs
	this.init = function(slide) {
		slide.addClass('js--slide');

		var upBtn = $('<a>', {
			'href': baseUrl + 'ajax/slides/reorder/' + $('.slide-content', slide).attr('data-id') + '/up',
			'text': 'Up',
			'class': 's s--up'
		});

		var downBtn = $('<a>', {
			'href': baseUrl + 'ajax/slides/reorder/' + $('.slide-content', slide).attr('data-id'),
			'text': 'Down',
			'class': 's s--down'
		});

		$('label.reorder', slide).append(upBtn).append(downBtn);

		var _this = this;

		slide.on('click', 'label > a', function(e){
			e.preventDefault();

			$.ajax({
				'url': $(this).attr('href'),
				'dataType': 'json',
				'success': function(data) {
					_this._reorder(slide, data);
				},
				'cache': false
			});
		});

	};

	this.remove = function(file) {

		$('label > a', file).remove();

		file.removeClass('js--slide');

	};

	// Reorder the slide inputs based on AJAX response
	this._reorder = function(slide, data) {

		if (data===null) {
			return;
		}

		var adjacent = $('.slide-content[data-id="' + data.adjacent.id + '"]').parents('.js--slide');

		// Update the sequence data
		$('.slide-content', slide).attr('data-sequence', data.current.sequence);
		$('.slide-content', adjacent).attr('data-sequence', data.adjacent.sequence);

		if (data.current.sequence>data.adjacent.sequence) {

			slide.before(adjacent);

		} else {

			slide.after(adjacent);

		}

	};

}
